import { GeneratedType, Registry } from "@cosmjs/proto-signing";
import { MsgInit, MsgExecute } from "./tx";
export declare const registry: ReadonlyArray<[string, GeneratedType]>;
export declare const load: (protoRegistry: Registry) => void;
export declare const MessageComposer: {
    encoded: {
        init(value: MsgInit): {
            typeUrl: string;
            value: Uint8Array;
        };
        execute(value: MsgExecute): {
            typeUrl: string;
            value: Uint8Array;
        };
    };
    withTypeUrl: {
        init(value: MsgInit): {
            typeUrl: string;
            value: MsgInit;
        };
        execute(value: MsgExecute): {
            typeUrl: string;
            value: MsgExecute;
        };
    };
    fromPartial: {
        init(value: MsgInit): {
            typeUrl: string;
            value: MsgInit;
        };
        execute(value: MsgExecute): {
            typeUrl: string;
            value: MsgExecute;
        };
    };
};
