import { Rpc } from "../../../helpers";
import { MsgInit, MsgInitResponse, MsgExecute, MsgExecuteResponse } from "./tx";
/** Msg defines the Msg service for the x/accounts module. */
export interface Msg {
    /** Init creates a new account in the chain. */
    init(request: MsgInit): Promise<MsgInitResponse>;
    /** Execute executes a message to the target account. */
    execute(request: MsgExecute): Promise<MsgExecuteResponse>;
}
export declare class MsgClientImpl implements Msg {
    private readonly rpc;
    constructor(rpc: Rpc);
    init: (request: MsgInit) => Promise<MsgInitResponse>;
    execute: (request: MsgExecute) => Promise<MsgExecuteResponse>;
}
