"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MsgClientImpl = void 0;
const binary_1 = require("../../../binary");
const tx_1 = require("./tx");
class MsgClientImpl {
    rpc;
    constructor(rpc) {
        this.rpc = rpc;
    }
    /* Init creates a new account in the chain. */
    init = async (request) => {
        const data = tx_1.MsgInit.encode(request).finish();
        const promise = this.rpc.request("cosmos.accounts.v1.Msg", "Init", data);
        return promise.then(data => tx_1.MsgInitResponse.decode(new binary_1.BinaryReader(data)));
    };
    /* Execute executes a message to the target account. */
    execute = async (request) => {
        const data = tx_1.MsgExecute.encode(request).finish();
        const promise = this.rpc.request("cosmos.accounts.v1.Msg", "Execute", data);
        return promise.then(data => tx_1.MsgExecuteResponse.decode(new binary_1.BinaryReader(data)));
    };
}
exports.MsgClientImpl = MsgClientImpl;
//# sourceMappingURL=tx.rpc.msg.js.map